#ifndef GRAPH
#define GRAPH

#include "main.h"
#include "IO.h"
#include "Connected.h"
#include "ShortestPath.h"

using namespace std;

int getArcWeight(Graph& G, int u, int v);
int deleteArc(Graph& G, int u, int v);
void addArc(Graph& G, int u, int v, int w);
bool existsArc(Graph& G, int u, int v);
int getNHeaviestWeights(Graph& G);
int getHeaviestTwoWeightsFromEachVertex(Graph& G);
void trimGraph(Graph& G, Sol& C, Sol& BSF, int UB);
Graph getInducedGraph(Graph& G, set<int>& X);
Graph makeGraph(vector<set<Neighbour, minNeighbour> >& adjList, vector<string>& vName, int targetK, int s);

#endif //GRAPH